import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.Random;
import java.util.ArrayList;
/**
 * Write a description of class MyWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MyWorld extends World
{
    private Random rand = new Random();
    private final int WIDTH = 11, HEIGHT = 9, SCALE = 60;
    /**
     * Constructor for objects of class MyWorld.
     * 
     */
    public MyWorld()
    {  
        super(11, 9, 60); //660,540, 1
        setBackground("sand2.jpg");
        
        setPaintOrder(PlayTimeIsUp.class, Explosion.class, Bomberman.class, Bush.class);
        
        for(int i = 1; i < HEIGHT; i += 2)
        {
            for(int j = 1; j < WIDTH; j += 2)
            {
                addObject(new BlockBush(), j, i);
            }
        }
        
        addObject(new PlayerTwo(), 0, 0);
        addObject(new PlayerOne(), WIDTH, HEIGHT);
        
        for(int i = 0; i < 20; i++)
        {
            boolean objectAdded = false;
            int x = rand.nextInt(WIDTH);
            int y = rand.nextInt(HEIGHT);
            while(!objectAdded)
            {
                ArrayList<Object> objs = (ArrayList<Object>) getObjectsAt(x, y, Object.class);
                if(objs.size() <= 0)
                {
                    Bush Bush = new Bush();
                    addObject(Bush, x, y);
                    objectAdded = true;
                }
                else
                {
                    x = rand.nextInt(WIDTH);
                    y = rand.nextInt(HEIGHT);
                }
            }
        }
        
        PowerUp power = new PowerUp();
        addObject(power, 0, 0);
        power.getImage().clear();
        power.addPowerUp(Speed.class, NumberOfBombs.class, RadiusOfBomb.class);
    }
    
    /**
     * Gets the current scale of the world
     * 
     * @return An int value for the scale of the world (how many pixels per cell)
     */
    public int getScale()
    {
        return SCALE;
    }
    
    public void PlayTimeIsUp() 
    {
        addObject(new PlayTimeIsUp(), getWidth()/2, getHeight()/2);
        Greenfoot.stop();
    }
}
